require 'active_support/core_ext/module/delegation'
require 'active_record/relation'

module Randone
  # https://github.com/rails/rails/blob/master/activerecord/lib/active_record/relation/query_methods.rb
  module ActiveRecord
    module Relation
      def randone
        where( 'id >= ?', rand(first.id..last.id) ).first
      end
    end # Relation

    # Class methods
    # where(nil) is because:
    # http://stackoverflow.com/questions/18198963/with-rails-4-model-scoped-is-deprecated-but-model-all-cant-replace-it
    module Base
      def randone
        where(nil).randone
      end
    end

  end # Active Record
end # Randone
